/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../../mozilla/netwerk/mime/public/nsIMIMEInfo.idl
 */

#ifndef __gen_nsIMIMEInfo_h__
#define __gen_nsIMIMEInfo_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIFile; /* forward declaration */

typedef PRInt32 nsMIMEInfoHandleAction;


/* starting interface:    nsIMIMEInfo */
#define NS_IMIMEINFO_IID_STR "6a57eae0-2fe8-11d3-a164-0050041caf44"

#define NS_IMIMEINFO_IID \
  {0x6a57eae0, 0x2fe8, 0x11d3, \
    { 0xa1, 0x64, 0x00, 0x50, 0x04, 0x1c, 0xaf, 0x44 }}

class NS_NO_VTABLE nsIMIMEInfo : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMIMEINFO_IID)

  /**
     * Gives you an array of file types associated with this type.
     *
     * @return Number of elements in the array.
     * @return Array of extensions.
     */
  /* void GetFileExtensions (out PRUint32 elementCount, [array, size_is (elementCount)] out string extensions); */
  NS_IMETHOD GetFileExtensions(PRUint32 *elementCount, char ***extensions) = 0;

  /**
     * Set File Extensions. Input is a comma delimited list of extensions.
     */
  /* void SetFileExtensions (in string aExtensions); */
  NS_IMETHOD SetFileExtensions(const char *aExtensions) = 0;

  /**
     * Returns whether or not the given extension is
     * associated with this MIME info.
     *
     * @return TRUE if the association exists. 
     */
  /* boolean ExtensionExists (in string aExtension); */
  NS_IMETHOD ExtensionExists(const char *aExtension, PRBool *_retval) = 0;

  /**
     * Append a given extension to the set of extensions
     */
  /* void AppendExtension (in string aExtension); */
  NS_IMETHOD AppendExtension(const char *aExtension) = 0;

  /**
     * Returns a clone of this MIMEInfo.
     *
     * @return A clone of the MIMEInfo
     */
  /* nsIMIMEInfo clone (); */
  NS_IMETHOD Clone(nsIMIMEInfo **_retval) = 0;

  /**
     * Returns the first extension association in
     * the internal set of extensions.
     *
     * @return The first extension.
     */
  /* attribute string primaryExtension; */
  NS_IMETHOD GetPrimaryExtension(char * *aPrimaryExtension) = 0;
  NS_IMETHOD SetPrimaryExtension(const char * aPrimaryExtension) = 0;

  /**
     * The MIME type of this MIMEInfo.
     * 
     * @return String representing the MIME type.
     */
  /* attribute string MIMEType; */
  NS_IMETHOD GetMIMEType(char * *aMIMEType) = 0;
  NS_IMETHOD SetMIMEType(const char * aMIMEType) = 0;

  /**
     * A human readable description of the MIME info.
     *
     * @return The description
     */
  /* attribute wstring Description; */
  NS_IMETHOD GetDescription(PRUnichar * *aDescription) = 0;
  NS_IMETHOD SetDescription(const PRUnichar * aDescription) = 0;

  /**
     * Gives you arbitrary data about the MIMEInfo. An example
     * of this is a generic image graphically representing
     * this MIME info. This image can be used to generically
     * and graphically represent the type.
     *
     * @return A URI representing the data location.
     */
  /* readonly attribute nsIURI DataURI; */
  NS_IMETHOD GetDataURI(nsIURI * *aDataURI) = 0;

  /**
     * Mac Type and creator types
     */
  /* attribute PRUint32 MacType; */
  NS_IMETHOD GetMacType(PRUint32 *aMacType) = 0;
  NS_IMETHOD SetMacType(PRUint32 aMacType) = 0;

  /* attribute PRUint32 MacCreator; */
  NS_IMETHOD GetMacCreator(PRUint32 *aMacCreator) = 0;
  NS_IMETHOD SetMacCreator(PRUint32 aMacCreator) = 0;

  /**
     * Returns whether or not these two MIME infos are logically
     * equivalent maintaining the one-to-many relationship between
     * MIME types and file extensions.
     *
     * @returns TRUE if the two are considered equal
     */
  /* boolean Equals (in nsIMIMEInfo aMIMEInfo); */
  NS_IMETHOD Equals(nsIMIMEInfo *aMIMEInfo, PRBool *_retval) = 0;

  /**
     * Returns a nsIFile that points to the application the user has said
     * they want associated with this content type. This is not always
     * guaranteed to be set!!
     */
  /* attribute nsIFile preferredApplicationHandler; */
  NS_IMETHOD GetPreferredApplicationHandler(nsIFile * *aPreferredApplicationHandler) = 0;
  NS_IMETHOD SetPreferredApplicationHandler(nsIFile * aPreferredApplicationHandler) = 0;

  /**
     * a pretty name description of the associated application
     */
  /* attribute wstring applicationDescription; */
  NS_IMETHOD GetApplicationDescription(PRUnichar * *aApplicationDescription) = 0;
  NS_IMETHOD SetApplicationDescription(const PRUnichar * aApplicationDescription) = 0;

  /**
     * Returns a nsIFile that points to the application that is associated
     * by default with this content type.  This will usually be specified in
     * the platform settings somehow.  This is not always guaranteed
     * to be set!!
     */
  /* attribute nsIFile defaultApplicationHandler; */
  NS_IMETHOD GetDefaultApplicationHandler(nsIFile * *aDefaultApplicationHandler) = 0;
  NS_IMETHOD SetDefaultApplicationHandler(nsIFile * aDefaultApplicationHandler) = 0;

  /**
     * a pretty name description of the default application
     */
  /* attribute wstring defaultDescription; */
  NS_IMETHOD GetDefaultDescription(PRUnichar * *aDefaultDescription) = 0;
  NS_IMETHOD SetDefaultDescription(const PRUnichar * aDefaultDescription) = 0;

  enum { saveToDisk = 0 };

  enum { alwaysAsk = 1 };

  enum { useHelperApp = 2 };

  enum { handleInternally = 3 };

  enum { useSystemDefault = 4 };

  /**
     * preferredAction is how the user specified they would like to handle
     * this content type: save to disk, use specified helper app, use OS
     * default handler or handle using navigator.
     */
  /* attribute nsMIMEInfoHandleAction preferredAction; */
  NS_IMETHOD GetPreferredAction(nsMIMEInfoHandleAction *aPreferredAction) = 0;
  NS_IMETHOD SetPreferredAction(nsMIMEInfoHandleAction aPreferredAction) = 0;

  /**
     * alwaysAskBeforeHandling: if true, we should always give the user a
     * dialog asking how to dispose of this content.
     */
  /* attribute boolean alwaysAskBeforeHandling; */
  NS_IMETHOD GetAlwaysAskBeforeHandling(PRBool *aAlwaysAskBeforeHandling) = 0;
  NS_IMETHOD SetAlwaysAskBeforeHandling(PRBool aAlwaysAskBeforeHandling) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMIMEINFO \
  NS_IMETHOD GetFileExtensions(PRUint32 *elementCount, char ***extensions); \
  NS_IMETHOD SetFileExtensions(const char *aExtensions); \
  NS_IMETHOD ExtensionExists(const char *aExtension, PRBool *_retval); \
  NS_IMETHOD AppendExtension(const char *aExtension); \
  NS_IMETHOD Clone(nsIMIMEInfo **_retval); \
  NS_IMETHOD GetPrimaryExtension(char * *aPrimaryExtension); \
  NS_IMETHOD SetPrimaryExtension(const char * aPrimaryExtension); \
  NS_IMETHOD GetMIMEType(char * *aMIMEType); \
  NS_IMETHOD SetMIMEType(const char * aMIMEType); \
  NS_IMETHOD GetDescription(PRUnichar * *aDescription); \
  NS_IMETHOD SetDescription(const PRUnichar * aDescription); \
  NS_IMETHOD GetDataURI(nsIURI * *aDataURI); \
  NS_IMETHOD GetMacType(PRUint32 *aMacType); \
  NS_IMETHOD SetMacType(PRUint32 aMacType); \
  NS_IMETHOD GetMacCreator(PRUint32 *aMacCreator); \
  NS_IMETHOD SetMacCreator(PRUint32 aMacCreator); \
  NS_IMETHOD Equals(nsIMIMEInfo *aMIMEInfo, PRBool *_retval); \
  NS_IMETHOD GetPreferredApplicationHandler(nsIFile * *aPreferredApplicationHandler); \
  NS_IMETHOD SetPreferredApplicationHandler(nsIFile * aPreferredApplicationHandler); \
  NS_IMETHOD GetApplicationDescription(PRUnichar * *aApplicationDescription); \
  NS_IMETHOD SetApplicationDescription(const PRUnichar * aApplicationDescription); \
  NS_IMETHOD GetDefaultApplicationHandler(nsIFile * *aDefaultApplicationHandler); \
  NS_IMETHOD SetDefaultApplicationHandler(nsIFile * aDefaultApplicationHandler); \
  NS_IMETHOD GetDefaultDescription(PRUnichar * *aDefaultDescription); \
  NS_IMETHOD SetDefaultDescription(const PRUnichar * aDefaultDescription); \
  NS_IMETHOD GetPreferredAction(nsMIMEInfoHandleAction *aPreferredAction); \
  NS_IMETHOD SetPreferredAction(nsMIMEInfoHandleAction aPreferredAction); \
  NS_IMETHOD GetAlwaysAskBeforeHandling(PRBool *aAlwaysAskBeforeHandling); \
  NS_IMETHOD SetAlwaysAskBeforeHandling(PRBool aAlwaysAskBeforeHandling); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMIMEINFO(_to) \
  NS_IMETHOD GetFileExtensions(PRUint32 *elementCount, char ***extensions) { return _to GetFileExtensions(elementCount, extensions); } \
  NS_IMETHOD SetFileExtensions(const char *aExtensions) { return _to SetFileExtensions(aExtensions); } \
  NS_IMETHOD ExtensionExists(const char *aExtension, PRBool *_retval) { return _to ExtensionExists(aExtension, _retval); } \
  NS_IMETHOD AppendExtension(const char *aExtension) { return _to AppendExtension(aExtension); } \
  NS_IMETHOD Clone(nsIMIMEInfo **_retval) { return _to Clone(_retval); } \
  NS_IMETHOD GetPrimaryExtension(char * *aPrimaryExtension) { return _to GetPrimaryExtension(aPrimaryExtension); } \
  NS_IMETHOD SetPrimaryExtension(const char * aPrimaryExtension) { return _to SetPrimaryExtension(aPrimaryExtension); } \
  NS_IMETHOD GetMIMEType(char * *aMIMEType) { return _to GetMIMEType(aMIMEType); } \
  NS_IMETHOD SetMIMEType(const char * aMIMEType) { return _to SetMIMEType(aMIMEType); } \
  NS_IMETHOD GetDescription(PRUnichar * *aDescription) { return _to GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const PRUnichar * aDescription) { return _to SetDescription(aDescription); } \
  NS_IMETHOD GetDataURI(nsIURI * *aDataURI) { return _to GetDataURI(aDataURI); } \
  NS_IMETHOD GetMacType(PRUint32 *aMacType) { return _to GetMacType(aMacType); } \
  NS_IMETHOD SetMacType(PRUint32 aMacType) { return _to SetMacType(aMacType); } \
  NS_IMETHOD GetMacCreator(PRUint32 *aMacCreator) { return _to GetMacCreator(aMacCreator); } \
  NS_IMETHOD SetMacCreator(PRUint32 aMacCreator) { return _to SetMacCreator(aMacCreator); } \
  NS_IMETHOD Equals(nsIMIMEInfo *aMIMEInfo, PRBool *_retval) { return _to Equals(aMIMEInfo, _retval); } \
  NS_IMETHOD GetPreferredApplicationHandler(nsIFile * *aPreferredApplicationHandler) { return _to GetPreferredApplicationHandler(aPreferredApplicationHandler); } \
  NS_IMETHOD SetPreferredApplicationHandler(nsIFile * aPreferredApplicationHandler) { return _to SetPreferredApplicationHandler(aPreferredApplicationHandler); } \
  NS_IMETHOD GetApplicationDescription(PRUnichar * *aApplicationDescription) { return _to GetApplicationDescription(aApplicationDescription); } \
  NS_IMETHOD SetApplicationDescription(const PRUnichar * aApplicationDescription) { return _to SetApplicationDescription(aApplicationDescription); } \
  NS_IMETHOD GetDefaultApplicationHandler(nsIFile * *aDefaultApplicationHandler) { return _to GetDefaultApplicationHandler(aDefaultApplicationHandler); } \
  NS_IMETHOD SetDefaultApplicationHandler(nsIFile * aDefaultApplicationHandler) { return _to SetDefaultApplicationHandler(aDefaultApplicationHandler); } \
  NS_IMETHOD GetDefaultDescription(PRUnichar * *aDefaultDescription) { return _to GetDefaultDescription(aDefaultDescription); } \
  NS_IMETHOD SetDefaultDescription(const PRUnichar * aDefaultDescription) { return _to SetDefaultDescription(aDefaultDescription); } \
  NS_IMETHOD GetPreferredAction(nsMIMEInfoHandleAction *aPreferredAction) { return _to GetPreferredAction(aPreferredAction); } \
  NS_IMETHOD SetPreferredAction(nsMIMEInfoHandleAction aPreferredAction) { return _to SetPreferredAction(aPreferredAction); } \
  NS_IMETHOD GetAlwaysAskBeforeHandling(PRBool *aAlwaysAskBeforeHandling) { return _to GetAlwaysAskBeforeHandling(aAlwaysAskBeforeHandling); } \
  NS_IMETHOD SetAlwaysAskBeforeHandling(PRBool aAlwaysAskBeforeHandling) { return _to SetAlwaysAskBeforeHandling(aAlwaysAskBeforeHandling); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMIMEINFO(_to) \
  NS_IMETHOD GetFileExtensions(PRUint32 *elementCount, char ***extensions) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFileExtensions(elementCount, extensions); } \
  NS_IMETHOD SetFileExtensions(const char *aExtensions) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFileExtensions(aExtensions); } \
  NS_IMETHOD ExtensionExists(const char *aExtension, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExtensionExists(aExtension, _retval); } \
  NS_IMETHOD AppendExtension(const char *aExtension) { return !_to ? NS_ERROR_NULL_POINTER : _to->AppendExtension(aExtension); } \
  NS_IMETHOD Clone(nsIMIMEInfo **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Clone(_retval); } \
  NS_IMETHOD GetPrimaryExtension(char * *aPrimaryExtension) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrimaryExtension(aPrimaryExtension); } \
  NS_IMETHOD SetPrimaryExtension(const char * aPrimaryExtension) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPrimaryExtension(aPrimaryExtension); } \
  NS_IMETHOD GetMIMEType(char * *aMIMEType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMIMEType(aMIMEType); } \
  NS_IMETHOD SetMIMEType(const char * aMIMEType) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMIMEType(aMIMEType); } \
  NS_IMETHOD GetDescription(PRUnichar * *aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_IMETHOD SetDescription(const PRUnichar * aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDescription(aDescription); } \
  NS_IMETHOD GetDataURI(nsIURI * *aDataURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDataURI(aDataURI); } \
  NS_IMETHOD GetMacType(PRUint32 *aMacType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMacType(aMacType); } \
  NS_IMETHOD SetMacType(PRUint32 aMacType) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMacType(aMacType); } \
  NS_IMETHOD GetMacCreator(PRUint32 *aMacCreator) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMacCreator(aMacCreator); } \
  NS_IMETHOD SetMacCreator(PRUint32 aMacCreator) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMacCreator(aMacCreator); } \
  NS_IMETHOD Equals(nsIMIMEInfo *aMIMEInfo, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Equals(aMIMEInfo, _retval); } \
  NS_IMETHOD GetPreferredApplicationHandler(nsIFile * *aPreferredApplicationHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPreferredApplicationHandler(aPreferredApplicationHandler); } \
  NS_IMETHOD SetPreferredApplicationHandler(nsIFile * aPreferredApplicationHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPreferredApplicationHandler(aPreferredApplicationHandler); } \
  NS_IMETHOD GetApplicationDescription(PRUnichar * *aApplicationDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetApplicationDescription(aApplicationDescription); } \
  NS_IMETHOD SetApplicationDescription(const PRUnichar * aApplicationDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetApplicationDescription(aApplicationDescription); } \
  NS_IMETHOD GetDefaultApplicationHandler(nsIFile * *aDefaultApplicationHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultApplicationHandler(aDefaultApplicationHandler); } \
  NS_IMETHOD SetDefaultApplicationHandler(nsIFile * aDefaultApplicationHandler) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDefaultApplicationHandler(aDefaultApplicationHandler); } \
  NS_IMETHOD GetDefaultDescription(PRUnichar * *aDefaultDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultDescription(aDefaultDescription); } \
  NS_IMETHOD SetDefaultDescription(const PRUnichar * aDefaultDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDefaultDescription(aDefaultDescription); } \
  NS_IMETHOD GetPreferredAction(nsMIMEInfoHandleAction *aPreferredAction) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPreferredAction(aPreferredAction); } \
  NS_IMETHOD SetPreferredAction(nsMIMEInfoHandleAction aPreferredAction) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPreferredAction(aPreferredAction); } \
  NS_IMETHOD GetAlwaysAskBeforeHandling(PRBool *aAlwaysAskBeforeHandling) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAlwaysAskBeforeHandling(aAlwaysAskBeforeHandling); } \
  NS_IMETHOD SetAlwaysAskBeforeHandling(PRBool aAlwaysAskBeforeHandling) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAlwaysAskBeforeHandling(aAlwaysAskBeforeHandling); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMIMEInfo : public nsIMIMEInfo
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMIMEINFO

  nsMIMEInfo();
  virtual ~nsMIMEInfo();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMIMEInfo, nsIMIMEInfo)

nsMIMEInfo::nsMIMEInfo()
{
  /* member initializers and constructor code */
}

nsMIMEInfo::~nsMIMEInfo()
{
  /* destructor code */
}

/* void GetFileExtensions (out PRUint32 elementCount, [array, size_is (elementCount)] out string extensions); */
NS_IMETHODIMP nsMIMEInfo::GetFileExtensions(PRUint32 *elementCount, char ***extensions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void SetFileExtensions (in string aExtensions); */
NS_IMETHODIMP nsMIMEInfo::SetFileExtensions(const char *aExtensions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean ExtensionExists (in string aExtension); */
NS_IMETHODIMP nsMIMEInfo::ExtensionExists(const char *aExtension, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void AppendExtension (in string aExtension); */
NS_IMETHODIMP nsMIMEInfo::AppendExtension(const char *aExtension)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIMIMEInfo clone (); */
NS_IMETHODIMP nsMIMEInfo::Clone(nsIMIMEInfo **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string primaryExtension; */
NS_IMETHODIMP nsMIMEInfo::GetPrimaryExtension(char * *aPrimaryExtension)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetPrimaryExtension(const char * aPrimaryExtension)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute string MIMEType; */
NS_IMETHODIMP nsMIMEInfo::GetMIMEType(char * *aMIMEType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetMIMEType(const char * aMIMEType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute wstring Description; */
NS_IMETHODIMP nsMIMEInfo::GetDescription(PRUnichar * *aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetDescription(const PRUnichar * aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIURI DataURI; */
NS_IMETHODIMP nsMIMEInfo::GetDataURI(nsIURI * *aDataURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute PRUint32 MacType; */
NS_IMETHODIMP nsMIMEInfo::GetMacType(PRUint32 *aMacType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetMacType(PRUint32 aMacType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute PRUint32 MacCreator; */
NS_IMETHODIMP nsMIMEInfo::GetMacCreator(PRUint32 *aMacCreator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetMacCreator(PRUint32 aMacCreator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean Equals (in nsIMIMEInfo aMIMEInfo); */
NS_IMETHODIMP nsMIMEInfo::Equals(nsIMIMEInfo *aMIMEInfo, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIFile preferredApplicationHandler; */
NS_IMETHODIMP nsMIMEInfo::GetPreferredApplicationHandler(nsIFile * *aPreferredApplicationHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetPreferredApplicationHandler(nsIFile * aPreferredApplicationHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute wstring applicationDescription; */
NS_IMETHODIMP nsMIMEInfo::GetApplicationDescription(PRUnichar * *aApplicationDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetApplicationDescription(const PRUnichar * aApplicationDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIFile defaultApplicationHandler; */
NS_IMETHODIMP nsMIMEInfo::GetDefaultApplicationHandler(nsIFile * *aDefaultApplicationHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetDefaultApplicationHandler(nsIFile * aDefaultApplicationHandler)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute wstring defaultDescription; */
NS_IMETHODIMP nsMIMEInfo::GetDefaultDescription(PRUnichar * *aDefaultDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetDefaultDescription(const PRUnichar * aDefaultDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsMIMEInfoHandleAction preferredAction; */
NS_IMETHODIMP nsMIMEInfo::GetPreferredAction(nsMIMEInfoHandleAction *aPreferredAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetPreferredAction(nsMIMEInfoHandleAction aPreferredAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean alwaysAskBeforeHandling; */
NS_IMETHODIMP nsMIMEInfo::GetAlwaysAskBeforeHandling(PRBool *aAlwaysAskBeforeHandling)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMIMEInfo::SetAlwaysAskBeforeHandling(PRBool aAlwaysAskBeforeHandling)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_MIMEINFO_CID                           \
{ /* {95df6583-0001-11d4-a12b-a66ef662f0bc} */         \
    0x95df6583,                                      \
    0x0001,                                          \
    0x11d4,                                          \
    { 0xa1, 0x2b, 0xa6, 0x6e, 0xf6, 0x62, 0xf0, 0xbc } \
}
#define NS_MIMEINFO_CONTRACTID "@mozilla.org/mime-info;1"

#endif /* __gen_nsIMIMEInfo_h__ */
